## libopenobex2 1.5-0maemo3

=== CMakeLists.txt ===
cmake_minimum_required ( VERSION 2.6.3 FATAL_ERROR )

project ( openobex C )

#
# The project version
#
set ( VERSION_MAJOR 1 )
set ( VERSION_MINOR 6 )
set ( VERSION_PATCH 0 )
set ( VERSION "${VERSION_MAJOR}.${VERSION_MINOR}" )
if ( VERSION_PATCH GREATER 0 )
  set ( VERSION "${VERSION}.${VERSION_PATCH}" )
endif ( VERSION_PATCH GREATER 0 )

#
# The path for our own CMake modules
#
set ( CMAKE_MODULE_PATH
  ${PROJECT_SOURCE_DIR}/CMakeModules
)

#
# Define the default build type
#
set ( CMAKE_CONFIGURATION_TYPES "Release;Debug"
      CACHE STRING "" FORCE )
if ( NOT CMAKE_BUILD_TYPE )
  set ( CMAKE_BUILD_TYPE Release
        CACHE STRING "Build type" FORCE )
endif ( NOT CMAKE_BUILD_TYPE )

include ( MaintainerMode )

#
# define how to build libraries
#
option ( BUILD_SHARED_LIBS "Build shared libraries" ON )

#
# check common compiler flags
#
include ( CheckCCompilerFlag )
if ( CMAKE_COMPILER_IS_GNUCC )
  if ( UNIX AND NOT WIN32 )
    set ( COMPILER_FLAG_VISIBILITY -fvisibility=hidden )
    check_c_compiler_flag ( ${COMPILER_FLAG_VISIBILITY} COMPILER_SUPPORT_VISIBILITY )
  endif ( UNIX AND NOT WIN32 )

  set ( LINKER_FLAG_NOUNDEFINED   -Wl,--no-undefined )
  check_c_compiler_flag ( "${LINKER_FLAG_NOUNDEFINED}" COMPILER_SUPPORT_NOUNDEFINED )
endif ( CMAKE_COMPILER_IS_GNUCC )

if ( MSVC )
  # Some compiler options for MSVC to not print non-sense warnings.
  add_definitions ( -D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE )
endif ( MSVC )

#
# which transports shall be included
#
find_package ( Bluetooth )
set ( OPENOBEX_BLUETOOTH_AVAILABLE ${Bluetooth_FOUND} )

find_package ( Irda )
set ( OPENOBEX_IRDA_AVAILABLE ${Irda_FOUND} )

find_package ( LibUSB )
set ( OPENOBEX_USB_AVAILABLE ${LibUSB_FOUND} )

foreach ( transport BLUETOOTH IRDA USB )
  if ( OPENOBEX_${transport}_AVAILABLE )
    set ( OPENOBEX_${transport} ON
          CACHE BOOL "Build with ${transport} support")
  else ( OPENOBEX_${transport}_AVAILABLE )
    set ( OPENOBEX_${transport} OFF
          CACHE BOOL "Build with ${transport} support")
  endif ( OPENOBEX_${transport}_AVAILABLE )
endforeach ( transport )

if ( OPENOBEX_USB )
  if ( LibUSB_VERSION_1.0 )
    add_definitions ( -DHAVE_USB1 )
  endif ( LibUSB_VERSION_1.0 )
  add_definitions ( -DHAVE_USB )
endif ( OPENOBEX_USB )

if ( OPENOBEX_IRDA )
  add_definitions ( -DHAVE_IRDA )
  if ( WIN32 )
    add_definitions ( -DHAVE_IRDA_WINDOWS )
  else ( WIN32 )
    string ( TOUPPER "HAVE_IRDA_${CMAKE_SYSTEM_NAME}" IRDA_SYSTEM_DEFINITION )
    add_definitions ( -D${IRDA_SYSTEM_DEFINITION} )
  endif ( WIN32 )
endif ( OPENOBEX_IRDA )

if ( OPENOBEX_BLUETOOTH )
  add_definitions ( -DHAVE_BLUETOOTH )
  if ( WIN32 )
    add_definitions ( -DHAVE_BLUETOOTH_WINDOWS )
  else ( WIN32 )
    string ( TOUPPER "HAVE_BLUETOOTH_${CMAKE_SYSTEM_NAME}" BLUETOOTH_SYSTEM_DEFINITION )
    add_definitions ( -D${BLUETOOTH_SYSTEM_DEFINITION} )
  endif ( WIN32 )
endif ( OPENOBEX_BLUETOOTH )

#
# create pkg-config files
# these get copied and installed in the library dirs
# TODO: those files should be moved to subdirs for each library
#
set ( prefix      "${CMAKE_INSTALL_PREFIX}" )
set ( exec_prefix "\${prefix}" )
set ( libdir      "\${prefix}/lib${LIB_SUFFIX}" )
set ( includedir  "\${prefix}/include" )
set ( top_srcdir   "${CMAKE_SOURCE_DIR}" )
set ( top_builddir "${CMAKE_BINARY_DIR}" )
if ( OPENOBEX_BLUETOOTH AND UNIT AND NOT WIN32 )
  foreach ( lib Bluetooth_LIBRARIES )
    set ( LIBS_PRIVATE "${LIBS_PRIVATE} ${lib}" )
  endforeach ( lib )
endif ( OPENOBEX_BLUETOOTH AND UNIT AND NOT WIN32 )
if ( OPENOBEX_USB AND UNIX AND NOT WIN32 )
  if ( PKGCONFIG_LIBUSB_FOUND )
    if ( LibUSB_VERSION_1.0 )
      set ( REQUIRES "${REQUIRES} libusb-1.0" )
    else ( LibUSB_VERSION_1.0 )
      set ( REQUIRES "{REQUIRES} libusb" )
    endif ( LibUSB_VERSION_1.0 )
  else ( PKGCONFIG_LIBUSB_FOUND )
    foreach ( lib LibUSB_LIBRARIES )
      set ( LIBS_PRIVATE "${LIBS_PRIVATE} ${lib}" )
    endforeach ( lib )
  endif ( PKGCONFIG_LIBUSB_FOUND )
endif ( OPENOBEX_USB AND UNIX AND NOT WIN32 )
foreach ( file openobex openobex-glib )
  configure_file (
    ${CMAKE_CURRENT_SOURCE_DIR}/${file}.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/${file}.pc
    @ONLY
  )
endforeach ( file )

if ( NOT PKGCONFIG_INSTALL_DIR )
  set ( PKGCONFIG_INSTALL_DIR lib${LIB_SUFFIX}/pkgconfig
        CACHE PATH "Where to install .pc files to" FORCE )
endif ( NOT PKGCONFIG_INSTALL_DIR )
mark_as_advanced ( PKGCONFIG_INSTALL_DIR )


#
# process include directory
#
set ( openobex_INCLUDE_DIRS "${CMAKE_CURRENT_SOURCE_DIR}/include" )
include_directories ( "${openobex_INCLUDE_DIRS}" )
if ( MSVC )
  include_directories ( AFTER SYSTEM "${openobex_INCLUDE_DIRS}/msvc" )
endif ( MSVC )


#
# build the main library
#
add_subdirectory ( lib )
link_directories ( "${CMAKE_CURRENT_BINARY_DIR}/lib" )
if ( BUILD_SHARED_LIBS )
  add_definitions ( -DOPENOBEX_DLL )
endif ( BUILD_SHARED_LIBS )
add_subdirectory ( udev )

#
# build the applications
#
add_custom_target ( openobex-apps )
add_subdirectory ( apps )


#
# build the documentation
#
option ( BUILD_DOCUMENTATION "Build library and application documentation" ON)
if ( BUILD_DOCUMENTATION )
  if ( NOT DOCUMENTATION_INSTALL_DIR )
    set ( DOCUMENTATION_INSTALL_DIR share/doc/openobex
      CACHE PATH "Where to install generic documentation files to" FORCE )
  endif ( NOT DOCUMENTATION_INSTALL_DIR )
  mark_as_advanced ( DOCUMENTATION_INSTALL_DIR )

  if ( NOT MANPAGE_INSTALL_DIR )
    set ( MANPAGE_INSTALL_DIR share/man
      CACHE PATH "Where to install manpage files to" FORCE )
  endif ( NOT MANPAGE_INSTALL_DIR )
  mark_as_advanced ( MANPAGE_INSTALL_DIR )

  add_subdirectory ( doc )
endif ( BUILD_DOCUMENTATION )


#
# build the glib binding library
# not enabled by default because it requires an additional dependency
#
#option ( BUILD_GLIB_BINDING "Build the glib binding library")
#if ( BUILD_GLIB_BINDING )
#  add_subdirectory ( glib )
#endif ( BUILD_GLIB_BINDING )


#
# The following adds CPack support
#
set ( CPACK_PACKAGE_DESCRIPTION_SUMMARY "OpenObex" )
set ( CPACK_PACKAGE_VENDOR "The OpenObex Development Team" )

set ( CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING.LIB" )
set ( CPACK_RESOURCE_FILE_README  "${CMAKE_CURRENT_SOURCE_DIR}/README" )

set ( CPACK_PACKAGE_VERSION_MAJOR "${VERSION_MAJOR}" )
set ( CPACK_PACKAGE_VERSION_MINOR "${VERSION_MINOR}" )
set ( CPACK_PACKAGE_VERSION_PATCH "${VERSION_PATCH}" )
set ( CPACK_PACKAGE_VERSION       "${VERSION}" )

if ( UNIX )
  set ( CPACK_GENERATOR "TGZ" )
  set ( CPACK_SOURCE_GENERATOR "TGZ" )

elseif ( WIN32 )
  #
  # For NSIS, install from http://nsis.sf.net.
  # For ZIP, install e.g. info-zip from http://www.info-zip.org.
  #
  set ( CPACK_GENERATOR "ZIP;NSIS" )
  set ( CPACK_SOURCE_GENERATOR "ZIP" )
endif ( UNIX )
set ( CPACK_SOURCE_IGNORE_FILES
  "/build/"
  "/\\\\.git/"
  "/\\\\.gitignore$"
  "~$"
)

# this must _follow_ the settings!
include ( CPack )

=== apps/CMakeLists.txt ===

add_subdirectory ( lib )
include_directories( ${CMAKE_CURRENT_SOURCE_DIR}/lib )
add_subdirectory ( obex_test )
add_subdirectory ( ircp )

set ( OPENOBEX_COMMON_APPS
  irxfer
  irobex_palm3
)
set ( OPENOBEX_APPS
  obex_find
)

if ( NOT CMAKE_SYSTEM_NAME STREQUAL "Windows" )
  #obex_tcp uses functions that are only available
  #under Windows7, so we do not compile for now.
  list ( APPEND OPENOBEX_COMMON_APPS obex_tcp )
endif ( NOT CMAKE_SYSTEM_NAME STREQUAL "Windows" )

foreach ( prog ${OPENOBEX_COMMON_APPS} )
  list ( APPEND ${prog}_LIBS openobex-apps-common )
  list ( APPEND OPENOBEX_APPS ${prog} )
endforeach ( prog )

foreach ( prog ${OPENOBEX_APPS} )
  set ( ${prog}_SOURCES ${prog}.c )
  list ( APPEND ${prog}_LIBS openobex )
endforeach ( prog )

if ( WIN32 )
  list ( APPEND obex_tcp_LIBS ws2_32 )
endif ( WIN32 )

foreach ( prog ${OPENOBEX_APPS} )
  add_executable ( ${prog} EXCLUDE_FROM_ALL ${${prog}_SOURCES} )
  target_link_libraries ( ${prog} ${${prog}_LIBS} )
  get_target_property ( ${prog}_EXECUTABLE ${prog} LOCATION )
  install ( PROGRAMS ${${prog}_EXECUTABLE}
    DESTINATION bin
    COMPONENT applications
    OPTIONAL
  )
endforeach ( prog )
add_dependencies ( openobex-apps ${OPENOBEX_APPS} )

=== doc/CMakeLists.txt ===

add_custom_target ( doc )

set ( SOURCES
  "${CMAKE_SOURCE_DIR}/lib/obex.c"
  "${CMAKE_SOURCE_DIR}/include/openobex/obex.h"
  "${CMAKE_SOURCE_DIR}/include/openobex/obex_const.h"
  "${CMAKE_SOURCE_DIR}/doc/openobex.coverpage"
)

find_package( Doxygen )
if ( DOXYGEN_FOUND )
  set ( DOC_OUTPUT_TYPES
    HTML
    LATEX
  )
  set ( DOC_HTML_OUTPUT_FILE "index.html" )
  set ( DOC_LATEX_OUTPUT_FILE "refman.tex" )

  foreach ( type ${DOC_OUTPUT_TYPES} )
    foreach ( i ${DOC_OUTPUT_TYPES} )
      set ( DOC_${i}_OUTPUT "NO" )
    endforeach ( i )
    set ( DOC_${type}_OUTPUT "YES" )
    configure_file (
      ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
      ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile_${type}
      @ONLY
    )
    if ( DOC_${type}_OUTPUT_FILE )
      string ( TOLOWER "${type}" type_low )
      set ( DOC_${type}_OUTPUT_FILE_ABS "${CMAKE_CURRENT_BINARY_DIR}/${type_low}/${DOC_${type}_OUTPUT_FILE}" )

      add_custom_command ( OUTPUT "${DOC_${type}_OUTPUT_FILE_ABS}"
          COMMAND "${DOXYGEN_EXECUTABLE}" "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile_${type}"
          DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile_${type}" ${SOURCES}
          VERBATIM
      )

      add_custom_target ( apidoc_${type_low} DEPENDS ${DOC_${type}_OUTPUT_FILE_ABS} )
    endif ( DOC_${type}_OUTPUT_FILE )
  endforeach ( type )

  set_directory_properties ( PROPERTIES
    ADDITIONAL_MAKE_CLEAN_FILES "html;latex"
  )
  add_dependencies ( openobex apidoc_html )
  add_dependencies ( doc apidoc_html )

  install ( DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/html"
    DESTINATION ${DOCUMENTATION_INSTALL_DIR}
    COMPONENT documentation
  )
endif ( DOXYGEN_FOUND )

find_package ( Docbook )
if ( Docbook_FOUND )
  include ( ${Docbook_USE_FILE} )
  if ( UNIX )
    option (BUILD_APPS_HELP_MAN "Build manpage application help files" ON)
    option (BUILD_APPS_HELP_HTML "Build HTML application help files" OFF)
  else ( UNIX )
    option (BUILD_APPS_HELP_HTML "Build HTML application help files" ON)
  endif ( UNIX )

  set ( OPENOBEX_APP_XML_FILE "${CMAKE_CURRENT_SOURCE_DIR}/openobex-apps.xml" )
  if ( BUILD_APPS_HELP_MAN )
    docbook_generate ( manpage "${OPENOBEX_APP_XML_FILE}" XSLT_FILES_MAN )
    foreach ( file ${XSLT_FILES_MAN} )
      list ( APPEND OPENOBEX_HELP_FILES ${file} )
      get_filename_component ( fileExt ${file} EXT )
      string ( REGEX REPLACE "^[.]" "" fileExt ${fileExt} )
      install (
	FILES ${CMAKE_CURRENT_BINARY_DIR}/${file}
	DESTINATION ${MANPAGE_INSTALL_DIR}/man${fileExt}
	PERMISSIONS OWNER_READ OWNER_WRITE
                    GROUP_READ
                    WORLD_READ
	COMPONENT documentation
	OPTIONAL
      )
    endforeach ( file )
  endif ( BUILD_APPS_HELP_MAN )

  if ( BUILD_APPS_HELP_HTML )
    include ( UseDocbook )
    docbook_generate ( html "${OPENOBEX_APP_XML_FILE}" XSLT_FILES_HTML )
    foreach ( file ${XSLT_FILES_HTML} )
      list ( APPEND OPENOBEX_HELP_FILES ${file} )
      install (
	FILES ${CMAKE_CURRENT_BINARY_DIR}/${file}
	DESTINATION ${DOCUMENTATION_INSTALL_DIR}
	PERMISSIONS OWNER_READ OWNER_WRITE
                    GROUP_READ
                    WORLD_READ
        COMPONENT documentation
        OPTIONAL
      )
    endforeach ( file )
  endif ( BUILD_APPS_HELP_HTML )

  if ( OPENOBEX_HELP_FILES )
    add_custom_target ( openobex-apps-doc DEPENDS ${OPENOBEX_HELP_FILES} )
    add_dependencies ( openobex-apps openobex-apps-doc )
    add_dependencies ( doc openobex-apps-doc )
  endif ( OPENOBEX_HELP_FILES )
endif ( Docbook_FOUND )

=== lib/CMakeLists.txt ===
#
# Main library version and shared object version
#

# this defines supported properties that are set from
# variables of the form openobex_*
set ( openobex_PROPERTIES
  VERSION
  SOVERSION
  PUBLIC_HEADER
  COMPILE_DEFINITIONS
  COMPILE_FLAGS
  LINK_FLAGS
)

# the library version always matches the project version
foreach ( i VERSION VERSION_MAJOR VERSION_MINOR VERSION_PATCH )
  set ( openobex_${i}   "${${i}}" )
endforeach ( i )
# the ABI version, must be increased on incompatible changes
set ( openobex_SOVERSION "2" )


set ( SOURCES
  obex.c
  obex_client.c
  obex_connect.c
  obex_header.c
  obex_main.c
  obex_object.c
  obex_server.c
  obex_transport.c
  databuffer.c
  inobex.c
  fdobex.c
  customtrans.c
)

set ( HEADERS
  obex_client.h
  obex_connect.h
  obex_header.h
  obex_main.h
  obex_object.h
  obex_server.h
  obex_transport.h
  databuffer.h
  debug.h
  defines.h
  obex_incl.h
  visibility.h
  inobex.h
  fdobex.h
  customtrans.h
  cloexec.h
)

set ( openobex_PUBLIC_HEADER
  ${openobex_INCLUDE_DIRS}/openobex/obex.h
  ${openobex_INCLUDE_DIRS}/openobex/obex_const.h
)

if ( CMAKE_SYSTEM_NAME STREQUAL "Linux" )
  # Activates some functions not defined without
  add_definitions ( -D_GNU_SOURCE )
endif ( CMAKE_SYSTEM_NAME STREQUAL "Linux" )

option ( ENABLE_DEBUG_MESSAGES "Enables debug messages printed during runtime" )
if ( ENABLE_DEBUG_MESSAGES )
  set ( DEBUG_LEVEL 1 CACHE STRING "Amount of debug message (1-4)" )
  list ( APPEND openobex_COMPILE_DEFINITIONS OBEX_DEBUG=${DEBUG_LEVEL} )
  if ( NOT CMAKE_SYSTEM_NAME STREQUAL "Windows" )
     option ( DEBUG_USE_SYSLOG "Use SysLog facility instead of stderr for debug messages" )
  endif ( NOT CMAKE_SYSTEM_NAME STREQUAL "Windows" )
  if ( DEBUG_USE_SYSLOG )
    list ( APPEND openobex_COMPILE_DEFINITIONS OBEX_SYSLOG )
  endif ( DEBUG_USE_SYSLOG )
endif ( ENABLE_DEBUG_MESSAGES )

option ( ENABLE_DUMP_MESSAGES "Enables dumping of data" )
if ( ENABLE_DUMP_MESSAGES )
  list ( APPEND openobex_COMPILE_DEFINITIONS OBEX_DUMP=3 )
endif ( ENABLE_DUMP_MESSAGES )

if ( OPENOBEX_IRDA )
  list ( APPEND SOURCES
    irobex.c
  )
  list ( APPEND HEADERS
    irobex.h
    irda_wrap.h
  )
endif ( OPENOBEX_IRDA )

if ( OPENOBEX_BLUETOOTH )
  list ( APPEND SOURCES
    btobex.c
  )
  list ( APPEND HEADERS
    btobex.h
    bluez_compat.h
  )
endif ( OPENOBEX_BLUETOOTH )

if ( OPENOBEX_USB )
  list ( APPEND openobex_LIBRARIES
    ${LibUSB_LIBRARIES}
  )
  include_directories ( BEFORE SYSTEM ${LibUSB_INCLUDE_DIRS} )
  if ( LibUSB_VERSION_1.0 )
    list ( APPEND SOURCES
      usb1obex.c
      usbutils.c
    )
  else ( LibUSB_VERSION_1.0 )
    list ( APPEND SOURCES
      usbobex.c
      usbutils.c
    )
  endif ( LibUSB_VERSION_1.0 )
  list ( APPEND HEADERS
    usbobex.h
    usbutils.h
  )
endif ( OPENOBEX_USB )

if ( COMPILER_SUPPORT_VISIBILITY )
  list ( APPEND openobex_COMPILE_DEFINITIONS HAVE_VISIBILITY )
  set ( openobex_COMPILE_FLAGS "${openobex_COMPILE_FLAGS} ${COMPILER_FLAG_VISIBILITY}" )
endif ( COMPILER_SUPPORT_VISIBILITY )
if ( COMPILER_SUPPORT_NOUNDEFINED )
  set ( openobex_LINK_FLAGS "${openobex_LINK_FLAGS} ${LINKER_FLAG_NOUNDEFINED}" )
endif ( COMPILER_SUPPORT_NOUNDEFINED )

if ( WIN32 )
  if ( CMAKE_COMPILER_IS_GNUCC )
    set ( openobex_LINK_FLAGS
      "${openobex_LINK_FLAGS} -Wl,--disable-stdcall-fixup -Wl,--add-stdcall-alias"
    )
  endif ( CMAKE_COMPILER_IS_GNUCC )

  list ( APPEND openobex_LIBRARIES
    ws2_32
  )

  if ( CMAKE_RC_COMPILER )
    set ( OPENOBEX_RC_FILE "${CMAKE_CURRENT_BINARY_DIR}/openobex.rc" )
    configure_file (
      "${CMAKE_CURRENT_SOURCE_DIR}/openobex.rc.in"
      "${OPENOBEX_RC_FILE}"
      @ONLY
    )
  endif ( CMAKE_RC_COMPILER )

  if ( MSVC )
    set ( OPENOBEX_DEF_FILE "${CMAKE_CURRENT_BINARY_DIR}/openobex.def" )
    file ( WRITE "${OPENOBEX_DEF_FILE}" "VERSION ${openobex_VERSION_MAJOR}.${openobex_VERSION_MINOR}\n" )
    file ( APPEND "${OPENOBEX_DEF_FILE}" "EXPORTS\n" )
    file ( READ "${CMAKE_CURRENT_SOURCE_DIR}/obex.sym" OPENOBEX_SYMBOLS )
    file ( APPEND "${OPENOBEX_DEF_FILE}" "${OPENOBEX_SYMBOLS}\n" )
  endif ( MSVC )
endif ( WIN32 )

if ( CYGWIN )
  #also define _WIN32 under CygWin
  list ( APPEND openobex_COMPILE_DEFINITIONS _WIN32)
endif ( CYGWIN )

# Add the openobex library target
add_library ( openobex
  ${SOURCES}
  ${HEADERS}
  ${openobex_PUBLIC_HEADER}
  ${OPENOBEX_RC_FILE}
  ${OPENOBEX_DEF_FILE}
)

target_link_libraries ( openobex
  ${openobex_LIBRARIES}
)
#disable link chaining
set_property(TARGET openobex PROPERTY LINK_INTERFACE_LIBRARIES "")

foreach ( i ${openobex_PROPERTIES} )
  if ( DEFINED openobex_${i} )
    set_property ( TARGET openobex PROPERTY ${i} ${openobex_${i}} )
  endif ( DEFINED openobex_${i} )
endforeach ( i )

set_property ( TARGET openobex PROPERTY
  DEFINE_SYMBOL OPENOBEX_EXPORTS
)

install ( TARGETS openobex
  RUNTIME       DESTINATION bin
  LIBRARY       DESTINATION lib${LIB_SUFFIX}
  ARCHIVE       DESTINATION lib${LIB_SUFFIX}
  PUBLIC_HEADER DESTINATION include/openobex
  COMPONENT library
)

#
# Copy the .pc file to install it only if the lib gets installed
#
add_custom_command ( TARGET openobex
  COMMAND ${CMAKE_COMMAND}
  ARGS    -E copy_if_different ${PROJECT_BINARY_DIR}/openobex.pc
          ${CMAKE_CURRENT_BINARY_DIR}/openobex.pc
  VERBATIM
)
install ( FILES ${CMAKE_CURRENT_BINARY_DIR}/openobex.pc
  DESTINATION ${PKGCONFIG_INSTALL_DIR}
  OPTIONAL
)


#  include ( GetPrerequisites )
#  get_prerequisites ( openobex CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS 0 1 )
include ( InstallRequiredSystemLibraries )

=== udev/CMakeLists.txt ===
if ( CMAKE_SYSTEM_NAME STREQUAL "Linux" AND OPENOBEX_USB )
  add_executable ( obex-check-device obex-check-device.c )
  target_link_libraries ( obex-check-device openobex )
  install ( TARGETS obex-check-device
    DESTINATION sbin
    COMPONENT system
  )

  # The udev rules file needs to be configured to have the right
  # path to obex-check-device.
  configure_file ( openobex.rules.in openobex.rules @ONLY )
  set ( UDEV_RULES_INSTALL_DIR /lib/udev/rules.d
        CACHE PATH "Where to install udev rules" )
  mark_as_advanced ( UDEV_RULES_INSTALL_DIR )
  install ( FILES ${CMAKE_CURRENT_BINARY_DIR}/openobex.rules
    DESTINATION $(UDEV_RULES_INSTALL_DIR)
    COMPONENT system
    RENAME 60-openobex.rules
  )
endif ( CMAKE_SYSTEM_NAME STREQUAL "Linux" AND OPENOBEX_USB )

=== apps/ircp/CMakeLists.txt ===

set ( ircp_SOURCES
  debug.h
  dirtraverse.c dirtraverse.h
  ircp.c        ircp.h
  ircp_client.c ircp_client.h
  ircp_io.c     ircp_io.h
  ircp_server.c ircp_server.h
)

add_executable ( ircp EXCLUDE_FROM_ALL ${ircp_SOURCES} )
target_link_libraries ( ircp openobex )
get_target_property ( ircp_EXECUTABLE ircp LOCATION )
install ( PROGRAMS ${ircp_EXECUTABLE}
  DESTINATION bin
  COMPONENT applications
  OPTIONAL
)
add_dependencies ( openobex-apps ircp )

=== apps/obex_test/CMakeLists.txt ===

add_executable ( obex_test EXCLUDE_FROM_ALL
  obex_test.c obex_test.h
  obex_test_client.c obex_test_client.h
  obex_test_server.c obex_test_server.h
  obex_test_cable.c obex_test_cable.h
)

target_link_libraries ( obex_test
  openobex-apps-common
  openobex
  ${Bluetooth_LIBRARIES}
)

if ( WIN32 )
  target_link_libraries ( obex_test ws2_32 )
endif ( WIN32 )

get_target_property ( obex_test_EXECUTABLE obex_test LOCATION )
install ( PROGRAMS ${obex_test_EXECUTABLE}
  DESTINATION bin
  COMPONENT applications
  OPTIONAL
)

add_dependencies ( openobex-apps obex_test )

=== debian/changelog ===
libopenobex2 (1.5-0maemo3) unstable; urgency=low

  * latest upstream version dd 20110218

 -- Marcel J.E. Mol <marcel@mesa.nl>  Fri, 13 Aug 2010 23:33:35 +0200

libopenobex2 (1.5) unstable; urgency=low

  * latest upstream version
  * bump to libopenobex2 to allow sideways installation with libopenobex1

 -- Marcel J.E. Mol <marcel@mesa.nl>  Fri, 13 Aug 2010 23:33:35 +0200

libopenobex1 (1.4-0maemo3+0m5) unstable; urgency=low

  * This entry has been added by BIFH queue processor
    Suffix +0m5 added to package revision

 -- Mika Linnanoja <mika.linnanoja@nokia.com>  Tue, 19 May 2009 16:27:34 +0300

libopenobex1 (1.4-0maemo3) unstable; urgency=low

  * Backport patch for NULL-check in obex_client.c
  * Fixes: NB#117503 - connectivity-ui-conndlgs crash on sender when BT is
    turned off by the receiver, during an ongoing file transfer

 -- Johan Hedberg <johan.hedberg@nokia.com>  Mon, 18 May 2009 18:14:24 +0300

libopenobex1 (1.4-0maemo2) unstable; urgency=low

  * Fix debug package creation issue caused by compat level change.

 -- Johan Hedberg <johan.hedberg@nokia.com>  Fri,  5 Dec 2008 12:25:10 +0000

libopenobex1 (1.4-0maemo1) unstable; urgency=low

  * New upstream release
  * Changes since 1.3 from upstream ChangeLog:
     - Add OBEX_ObjectGetSpace function.
     - Add OBEX_ObjectGetCommand function.
     - Add Bluetooth support for FreeBSD and NetBSD.
     - Add support for using OBEX over IPv6.
     - Add support for Win32 platform.
     - Fix support for document generation.
     - Fix public visible symbols of the libraries.
     - Fix handling of unexpected data from the server.
     - Fix return value interpretation of obex_object_send.
     - Fix obex_object_resume handling if sending fails.
     - Allow suspending before the first packet has been sent.

 -- Johan Hedberg <johan.hedberg@nokia.com>  Sun,  9 Nov 2008 18:18:03 +0000

libopenobex1 (1.3osso5) unstable; urgency=low

  * Remove libbluetooth dependency to keep package purely under the LGPL 

 -- Johan Hedberg <johan.hedberg@nokia.com>  Thu, 12 Jul 2007 05:47:31 +0300

libopenobex1 (1.3osso4) unstable; urgency=low

  * Fix debug package creation. Fixes: NB#48873 

 -- Johan Hedberg <johan.hedberg@nokia.com>  Fri,  1 Dec 2006 14:10:45 +0200

libopenobex1 (1.3osso3) unstable; urgency=low

  * Better sanity check for length headers. Fixes: #NB42704 

 -- Johan Hedberg <johan.hedberg@nokia.com>  Fri, 13 Oct 2006 16:11:28 +0300

libopenobex1 (1.3osso2) unstable; urgency=low

  * Add libopenobex1-dbg debug package 

 -- Johan Hedberg <johan.hedberg@nokia.com>  Tue, 19 Sep 2006 14:32:54 +0300

libopenobex1 (1.3osso1) unstable; urgency=low

  * Updated libbluetooth dependency

 -- Johan Hedberg <johan.hedberg@nokia.com>  Thu, 27 Jul 2006 13:35:12 +0300

libopenobex1 (1.3) unstable; urgency=low

  * New upstream version

 -- Johan Hedberg <johan.hedberg@nokia.com>  Wed, 21 Jun 2006 12:49:25 +0300

libopenobex1 (1.2) unstable; urgency=low

  * Upstream 1.2 version
  * Packages renamed to libopenobex1 and libopenobex1-dev 

 -- Johan Hedberg <johan.hedberg@nokia.com>  Thu, 23 Mar 2006 00:49:40 +0200

libopenobex1.1 (1.1-osso3) unstable; urgency=low

  * Add missing cdbs build-depends 

 -- Johan Hedberg <johan.hedberg@nokia.com>  Thu, 16 Feb 2006 19:16:01 +0200

libopenobex1.1 (1.1-osso2) unstable; urgency=low

  * Add libbluetooth1-dev dependency to openobex1.1-dev

 -- Johan Hedberg <johan.hedberg@nokia.com>  Thu, 16 Feb 2006 15:08:39 +0200

libopenobex1.1 (1.1-osso1) unstable; urgency=low

  * Unmodified version 1.1 of openobex

 -- Johan Hedberg <johan.hedberg@nokia.com>  Tue, 14 Feb 2006 15:58:02 +0200

libopenobex1.0 (1:1.0.0-rel-3) unstable; urgency=low

  * Acknowledge NMU.
  * Restored big-endian patch.
  * Add patch for obex_server.c to detect a read when object deleted.

 -- Edd Dumbill <ejad@debian.org>  Fri,  4 Jun 2004 00:51:04 +0100

libopenobex1.0 (1:1.0.0-rel-2.1) unstable; urgency=low
 
   * NMU if the maintainer does not react
   * Restored the Testing version with an epoched version because
     libopenobex1.0.1 is another library generation (closes: #214471)
  
 -- Eduard Bloch <blade@debian.org>  Sun, 12 Oct 2003 15:49:25 +0200

libopenobex1.0 (1.0.1-1) unstable; urgency=low

  * New upstream release.
  * Changed section of libopenobex-dev to 'libdevel'
  * Remove big-endian patch: now incorporated upstream.

 -- Edd Dumbill <ejad@debian.org>  Mon,  6 Oct 2003 13:37:48 +0100

libopenobex1.0 (1.0.0-rel-2) unstable; urgency=low

  * Moved to Colin's Build System
  * Incorporate patch from CVS to fix Bluetooth use on big-endian
    systems (thanks Marcel Holtmann)

 -- Edd Dumbill <ejad@debian.org>  Sun, 23 Mar 2003 14:53:33 +0000

libopenobex1.0 (1.0.0-rel-1) unstable; urgency=low

  * New upstream release

 -- Edd Dumbill <ejad@debian.org>  Mon,  2 Dec 2002 20:22:01 +0000

libopenobex1.0 (1.0.0-pre5-1) unstable; urgency=low

  * Unreleased.
  * New upstream release (Closes: #167327)
    - supports Bluetooth transport layer
    - removes dependency on glib-1.2
  * Renamed packages as source & binary compatibility broken from earlier
    releases.  Used scheme as per Junichi Uekawa's library packaging
    guide.

 -- Edd Dumbill <ejad@debian.org>  Sun, 17 Nov 2002 17:51:25 +0000

libopenobex (0.9.8-7) unstable; urgency=low
 
  * Make openobex-config output includes and libs for bringing in
    the glib dependencies (Closes: #170090)
 
 -- Edd Dumbill <ejad@debian.org>  Thu, 21 Nov 2002 22:57:42 +0000
 

libopenobex (0.9.8-6) unstable; urgency=low
 
  * Fixed the .so files to be in the right packages
  * Updated standards version to 3.5.8
  * Added Section to the source description
 
 -- Edd Dumbill <ejad@debian.org>  Mon, 18 Nov 2002 01:50:22 +0000

libopenobex (0.9.8-5) unstable; urgency=low

  * New maintainer
  * Added shlibs file
  * Added simple manpage for openobex-config

 -- Edd Dumbill <ejad@debian.org>  Mon, 18 Nov 2002 00:33:25 +0000

libopenobex (0.9.8-4) unstable; urgency=low



=== debian/control ===
Source: libopenobex2
Priority: optional
Section: admin
Maintainer: Johan Hedberg <johan.hedberg@nokia.com>
Build-Depends: debhelper (>> 4.0.0), autotools-dev, cdbs
Standards-Version: 3.7.2

Package: libopenobex2-dev
Section: libdevel
Architecture: any
Depends: libopenobex2 (= ${binary:Version}), libc6-dev | libc-dev
Description: OBEX protocol library - development files
 The Object Exchange protocol can best be described as binary HTTP.
 OBEX is optimised for ad-hoc wireless links and can be used to exchange
 all kind of objects like files, pictures, calendar entries (vCal)
 and business cards (vCard).
 .
 OBEX is builtin in devices like PDA's like the Palm Pilot, and mobile
 phones like the Ericsson R320, Siemens S25, Siemens S45, Siemens ME45,
 Nokia NM207 and Nokia 9110 Communicator.
 .
 This package contains the development files.

Package: libopenobex2
Section: libs
Depends: ${shlibs:Depends}
Architecture: any
Description: OBEX protocol library
 The Object Exchange protocol can best be described as binary HTTP.
 OBEX is optimised for ad-hoc wireless links and can be used to exchange
 all kind of objects like files, pictures, calendar entries (vCal)
 and business cards (vCard).
 .
 OBEX is builtin in devices like PDA's like the Palm Pilot, and mobile
 phones like the Ericsson R320, Siemens S25, Siemens S45, Siemens ME45,
 Nokia NM207 and Nokia 9110 Communicator.

Package: libopenobex2-dbg
Section: libdevel
Architecture: any
Depends: libopenobex2 (= ${binary:Version})
Description: Debug symbols for libopenobex2
 This package contains debug symbols for the libopenobex2 package.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/cdbs/1/rules/buildcore.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/simple-patchsys.mk
include /usr/share/cdbs/1/class/autotools.mk

DEB_DH_STRIP_ARGS := --dbg-package=libopenobex2-dbg

#DEB_SHLIBDEPS_INCLUDE = debian/libopenobex-1.1-0/usr/lib
